﻿using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Caching.Distributed;
using Newtonsoft.Json;
using RedisCache.Models;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;

namespace RedisCache.Controllers
{
 
    [ApiController]
    public class ProductController : ControllerBase
    {
        private readonly DbEmployeeContext _context;
       

        public ProductController(DbEmployeeContext context)
        {
            _context = context;
           
        }

        [HttpGet]
        [Route("api/Product/GetAll")]
        public async Task<IActionResult> GetAll()
        {
            var products = await _context.Products.ToListAsync();

            return Ok(products);
        }

        [HttpPost]
        [Route("api/Product/Create")]
        public async Task<IActionResult> Create(Product product)
        {
            var result= _context.Products.Add(product);
            _context.SaveChanges();
            return Ok(product);
        }

        [HttpPut]
        [Route("api/Product/Update")]
        public async Task<IActionResult> Update(Product product)
        {
           
                var existingProduct =await _context.Products.FirstOrDefaultAsync(x=>x.ProductID==product.ProductID);

                if (existingProduct != null)
                {
                    existingProduct.ProductName = product.ProductName;
                    existingProduct.ProductDescription = product.ProductDescription;
                    existingProduct.ProductCategory = product.ProductCategory;
                    existingProduct.SubCategory = product.SubCategory;
                    _context.SaveChanges();
                }
                else
                {
                    return NotFound();
                }
            

            return Ok("Success");
        }
        [HttpDelete]
        [Route("api/Product/Delete")]
        public async Task<IActionResult> Delete(int id)
        {

            var existingStudent = await _context.Products.FirstOrDefaultAsync(x => x.ProductID == id);

            _context.Entry(existingStudent).State = EntityState.Deleted;
           _context.SaveChanges();

            return Ok("Record Deleted");
        }

    }
}